// ENGLISH - Delphi - With Static Array
// Question 2
// Please see marking guideline for mark breakdown

unit uStop;

interface
  uses SysUtils;

  // Q2.1 - 1 Mark  
  type TStop = class
  
    // Q2.2 - 3 Marks
    private
      stopName : string;
      routeCodes : string;
      stopType : integer;
    public

      // Q2.3 - 3 Marks
      const
        STOPTYPE_CAFE = 1;
        STOPTYPE_SHELTER = 2;
        STOPTYPE_EXPRESS = 3;
        STOPTYPE_OTHER = 4;

      constructor Create(inStopName , inRouteCodes : string; inStopType : integer);
      function getStopTypeName() : string  ;
      function isPartOfRoute(r: char) : boolean;
      function toString() : string;
  end;

  implementation
   // Q2.4 - 7 Marks 
   constructor TStop.Create(inStopName , inRouteCodes : string; inStopType : integer);
   begin
     stopName := inStopName;
     routeCodes := inRouteCodes;

     if (inStopType = STOPTYPE_CAFE) or
         (inStopType = STOPTYPE_SHELTER) or
         (inStopType = STOPTYPE_EXPRESS) then
     begin
       stopType := inStopType;
     end
     else
     begin
       stopType := STOPTYPE_OTHER
     end;

   end;

   // Q2.5 - 3 Marks
   function TStop.getStopTypeName() : string ;
   begin
    case stopType of
      STOPTYPE_CAFE : Result := 'cafe';
      STOPTYPE_SHELTER : Result := 'shelter';
      STOPTYPE_EXPRESS : Result := 'express';
      else Result := 'other';
    end;
   end;


    // Q2.6 - 3 Marks
   function TStop.isPartOfRoute(r: char) : boolean;
   begin
     Result := Pos(r, routeCodes) > 0;

     // or use if
     {
	 if Pos(r, routeCodes) > 0 then
     begin
        Result := true
     end
     else
     begin
        Result := false
     end;
	 }
   end;


   // Q2.7 - 3 Marks
   function TStop.toString() : string;
   begin
     Result := getStopTypeName() + #9 + stopName
   end;

end.